defmodule Test12 do
  @moduledoc """
  Documentation for Test12.
  """

  @doc """
  Run a test computing means of a column.

  ## Examples

      iex> Test12.run_mean(count, data_set_name, column_name)
      iex> Test12.run_mean(count, data_set_name, column_name, :true)

  """
  @spec run_mean(integer(), String.t(), String.t(), boolean()) :: :ok
  def run_mean(count, data_set_name, column_name, verbose \\ :false) do
    reply = Test12.Test.start_mean(count, data_set_name, column_name, verbose)
    reply 
  end

  @doc """
  Run a test counting the elements (nodes) in an XML document.

  ## Examples

      iex> Test12.run_element_count(count, xml_file_name)
      iex> Test12.run_element_count(count, xml_file_name, :true)

  """
  @spec run_element_count(integer(), String.t(), boolean()) :: :ok
  def run_element_count(count, xml_file_name, verbose \\ :false) do
    reply = Test12.Test.start_element_count(count, xml_file_name, verbose)
    reply 
  end
end
