defmodule PoolboyApp.Worker do
  use GenServer

  def start_link(_) do
    GenServer.start_link(__MODULE__, nil, [])
  end

  def init(_) do
    pypath = '/home/dkuhlman/b1/Erlang/Elixir/test12/pylib:'
    pybinpath = '/home/dkuhlman/b1/Python/Anaconda/Anaconda3/bin/python'
    {:ok, python_pid} = :python.start([python_path: pypath, python: pybinpath])
    IO.puts("*** started python -- pid: #{inspect(python_pid)}")
    state = [pid: python_pid]
    {:ok, state}
  end

  def handle_call(
    {:mean, index, data_file_name, column_name, verbose}, _from, state) do
      #IO.puts("*** (handle_call) state: #{inspect(state)}")
      python_pid = state[:pid]
      if verbose do
        IO.puts("process #{inspect(self())} data file #{data_file_name}")
      end
      result = :python.call(
        python_pid,
        :pymod_datasci01,
        :mean,
        [index, data_file_name, column_name, verbose])
      {:reply, {:result, result}, state}
  end
  def handle_call(
    {:xml_count, index, xml_file_name, verbose}, _from, state) do
      python_pid = state[:pid]
      if verbose do
        IO.puts("process #{inspect(self())} data set #{xml_file_name}")
      end
      result = :python.call(
        python_pid,
        :pymod_xml01,
        :count_elements,
        [index, xml_file_name, verbose])
      {:reply, {:result, result}, state}
  end

  def terminate(_reason, state) do
    python_pid = state[:pid]
    :python.stop(python_pid)
    IO.puts("*** terminated")
  end

end
