"""
synopsis:
    Functions for used from Elixir called through Erlport.
functions:
    count_elements -- Count the elements in an xml file.  Return the count.
"""

from __future__ import print_function
import os
from lxml import etree
from erlport.erlterms import Atom


def count_elements(index, xml_file_name, verbose):
    """Count the elements in an xml file.  Return the count.
    """
    file_name = os.path.join(
        os.path.abspath('.'), 'pylib', xml_file_name.decode())
    if verbose:
        abspath = os.path.abspath('.')
        print("file_name: {}  abspath: {}".format(file_name, abspath))
    if not os.path.exists(file_name):
        msg = 'xml file "{}" not found'.format(file_name)
        if verbose:
            print(msg)
        return Atom(b'not_found'), msg
    doc = etree.parse(file_name)
    root = doc.getroot()
    count = 0
    for element in root.iter():
        count += 1
    if verbose:
        print('index: {}  file name: {}  count: {}'.format(
            index, xml_file_name, count))
    return index, xml_file_name, count


def test():
    # Must be run with current directory the parent of the directory
    #   that contains this file.
    count_elements(1, b'people.xml', True)


if __name__ == '__main__':
    #import ipdb; ipdb.set_trace()
    test()
